TF_VerifierImpl< SCHEME_OPTIONS > Class Template Reference

_ More...

`#include <pubkey.h>`

Inheritance diagram for TF_VerifierImpl< SCHEME_OPTIONS >:

## Public Types

typedef SCHEME_OPTIONS::PublicKey | KeyClass
typedef SCHEME_OPTIONS | SchemeOptions

## Public Member Functions

const KeyClass & | GetKey () const
KeyClass & | AccessKey ()
PublicKey & | AccessPublicKey ()
const PublicKey & | GetPublicKey () const
PrivateKey & | AccessPrivateKey ()
const PrivateKey & | GetPrivateKey () const
const KeyClass & | GetTrapdoorFunction () const
PK_MessageAccumulator * | NewSignatureAccumulator (RandomNumberGenerator &rng) const
PK_MessageAccumulator * | NewVerificationAccumulator () const
std::string | AlgorithmName () const
void | InputSignature (PK_MessageAccumulator &messageAccumulator, const byte *signature, size_t signatureLength) const
| input signature into a message accumulator
bool | VerifyAndRestart (PK_MessageAccumulator &messageAccumulator) const
| check whether messageAccumulator contains a valid signature and message, and restart messageAccumulator
DecodingResult | RecoverAndRestart (byte *recoveredMessage, PK_MessageAccumulator &recoveryAccumulator) const
| recover a message from its signature More...
size_t | SignatureLength () const
size_t | MaxRecoverableLength () const
size_t | MaxRecoverableLengthFromSignatureLength (size_t signatureLength) const
bool | IsProbabilistic () const
bool | AllowNonrecoverablePart () const
bool | RecoverablePartFirst () const
virtual bool | Verify (PK_MessageAccumulator *messageAccumulator) const
| check whether messageAccumulator contains a valid signature and message, and delete messageAccumulator (even in case of exception thrown)
virtual bool | VerifyMessage (const byte *message, size_t messageLen, const byte *signature, size_t signatureLength) const
| check whether input signature is a valid signature for input message
virtual DecodingResult | Recover (byte *recoveredMessage, PK_MessageAccumulator *messageAccumulator) const
| recover a message from its signature More...
virtual DecodingResult | RecoverMessage (byte *recoveredMessage, const byte *nonrecoverableMessage, size_t nonrecoverableMessageLength, const byte *signature, size_t signatureLength) const
| recover a message from its signature More...
virtual size_t | MaxSignatureLength (size_t recoverablePartLength=0) const
| maximum signature length produced for a given length of recoverable message part
virtual bool | SignatureUpfront () const
| if this function returns true, during verification you must input the signature before the message, otherwise you can input it at anytime */
CryptoMaterial & | AccessMaterial ()
| returns a reference to the crypto material used by this object
const CryptoMaterial & | GetMaterial () const
| returns a const reference to the crypto material used by this object
void | BERDecode (BufferedTransformation &bt)
| for backwards compatibility, calls AccessMaterial().Load(bt)
void | DEREncode (BufferedTransformation &bt) const
| for backwards compatibility, calls GetMaterial().Save(bt)
virtual Clonable * | Clone () const
| this is not implemented by most classes yet

## Static Public Member Functions

static std::string | StaticAlgorithmName ()

## Protected Types

typedef TrapdoorFunction | TrapdoorFunctionInterface
typedef PK_SignatureMessageEncodingMethod | MessageEncodingInterface

## Protected Member Functions

const TF_VerifierBase::MessageEncodingInterface & | GetMessageEncodingInterface () const
const TrapdoorFunctionBounds & | GetTrapdoorFunctionBounds () const
const TF_VerifierBase::TrapdoorFunctionInterface & | GetTrapdoorFunctionInterface () const
HashIdentifier | GetHashIdentifier () const
size_t | GetDigestSize () const
size_t | MessageRepresentativeLength () const
size_t | MessageRepresentativeBitLength () const

## Detailed Description

### template<class SCHEME_OPTIONS>
class TF_VerifierImpl< SCHEME_OPTIONS >

_

Definition at line 469 of file pubkey.h.

## Member Function Documentation

DecodingResult TF_VerifierBase::RecoverAndRestart | ( | byte * | recoveredMessage,
|  | PK_MessageAccumulator & | messageAccumulator
| ) |  | const

virtual inherited

recover a message from its signature

Precondition
  size of recoveredMessage == MaxRecoverableLengthFromSignatureLength(signatureLength)

Implements PK_Verifier.

virtual DecodingResult PK_Verifier::Recover | ( | byte * | recoveredMessage,
|  | PK_MessageAccumulator * | messageAccumulator
| ) |  | const

virtual inherited

recover a message from its signature

Precondition
  size of recoveredMessage == MaxRecoverableLengthFromSignatureLength(signatureLength)

virtual DecodingResult PK_Verifier::RecoverMessage | ( | byte * | recoveredMessage,
|  | const byte * | nonrecoverableMessage,
|  | size_t | nonrecoverableMessageLength,
|  | const byte * | signature,
|  | size_t | signatureLength
| ) |  | const

virtual inherited

recover a message from its signature

Precondition
  size of recoveredMessage == MaxRecoverableLengthFromSignatureLength(signatureLength)

The documentation for this class was generated from the following file:

- pubkey.h